// obj = onject, updatedProperties = Object to add in obj
function updateObject(obj, updatedProperties) {
  return {
    ...obj,
    ...updatedProperties,
  };
}

// arr = array, updatedObject = Object to add in arr
function updateArray(arr, updatedObject) {
  return [...arr, { ...updatedObject }];
}

// arr = array, sortBy = 'string' key name that you want to short, Take 'string' for ascending 'ASC' and for descending 'DESC'
function shortArray(arr, sortBy, type) {
  const orderArrays = (cur, nxt) => {
    let current = cur;
    let next = nxt;
    if (typeof curr !== "number" && typeof next !== "number") {
      current = cur.toUpperCase();
      next = nxt.toUpperCase();
    }

    if (current > next) {
      return 1;
    } else if (current < next) {
      return -1;
    } else {
      return 0;
    }
  };

  if (type === "ASC") {
    return arr.sort((a, b) => orderArrays(a[sortBy], b[sortBy]));
  } else {
    return arr.sort((a, b) => orderArrays(b[sortBy], a[sortBy]));
  }
}
// arr = array, indexBy = 'string' key name that you want to get indexOf, indexOf = 'string' value that you want to get index
function getIndexBy(arr, indexBy, indexOf) {
  let toReturn = -1;
  arr.forEach((item, index) => {
    if (item[indexBy] === indexOf) {
      toReturn = index;
    }
  });
  return toReturn;
}

// name = 'string' Full name
function shortNameGenerate(name) {
  let shortNameToReturn = "";
  if (name) {
    let splitName = name.split(" ").filter((item) => item !== "");
    let splitNameLength = splitName.length;
    if (splitNameLength <= 1) {
      shortNameToReturn = name.substring(0, 2);
    } else {
      let firstName = splitName[0];
      let lastName = splitName[splitNameLength - 1];
      shortNameToReturn = firstName.substring(0, 1) + lastName.substring(0, 1);
    }
  }
  return shortNameToReturn.toUpperCase();
}

module.exports.updateObject = updateObject;
module.exports.updateArray = updateArray;
module.exports.shortArray = shortArray;
module.exports.getIndexBy = getIndexBy;
module.exports.shortNameGenerate = shortNameGenerate;
